/* Copyright 2017 Andrew Dawson
 *
 * This file is a part of Tusky.
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Tusky is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with Tusky; if not,
 * see <http://www.gnu.org/licenses>.
 */

package com.keylesspalace.tusky.entity

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

/**
 * Created by charlag on 1/4/18.
 */
@JsonClass(generateAdapter = true)
data class MastoList(
    val id: String,
    val title: String,
    val exclusive: Boolean? = null,
    @Json(name = "replies_policy") val repliesPolicy: String? = null
) {
    enum class ReplyPolicy(val policy: String) {
        NONE("none"),
        LIST("list"),
        FOLLOWED("followed");

        companion object {
            fun from(policy: String?): ReplyPolicy =
                entries.firstOrNull { it.policy == policy } ?: LIST
        }
    }
}
